All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 repository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous substring, so
125 "mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 If no number if specified, just operate on the repository for the current
158 directory, do not recurse into deeper repositories.
160 If a number is specified, will recurse into repositories at most that many
161 subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
162 but not ./src/packages/bar.
166 Run the specified number of jobs in parallel, or an unlimited number of jobs
167 with no number specified. This can greatly speed up operations such as updates.
168 It is not recommended for interactive operations.
170 Note that running more than 10 jobs at a time is likely to run afoul of
171 ssh connection limits. Running between 3 and 5 jobs at a time will yeild
172 a good speedup in updates without loading the machine too much.
178 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
179 file in your home directory, and this can in turn chain load .mrconfig files
182 Here is an example .mrconfig file:
185 checkout = svn co svn://svn.example.com/src/trunk src
189 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
191 git checkout -b mybranch origin/master
193 The .mrconfig file uses a variant of the INI file format. Lines starting with
194 "#" are comments. Values can be continued to the following line by
195 indenting the line with whitespace.
197 The "DEFAULT" section allows setting default values for the sections that
200 The "ALIAS" section allows adding aliases for actions. Each parameter
201 is an alias, and its value is the action to use.
203 All other sections add repositories. The section header specifies the
204 directory where the repository is located. This is relative to the directory
205 that contains the mrconfig file, but you can also choose to use absolute
208 Within a section, each parameter defines a shell command to run to handle a
209 given action. mr contains default handlers for "update", "status",
210 "commit", and other standard actions. Normally you only need to specify what
211 to do for "checkout".
213 Note that these shell commands are run in a "set -e" shell
214 environment, where any additional parameters you pass are available in
215 "$@". The "checkout" command is run in the parent of the repository
216 directory, since the repository isn't checked out yet. All other commands
217 are run inside the repository, though not necessarily at the top of it.
219 The "MR_REPO" environment variable is set to the path to the top of the
220 repository. (For the "register" action, "MR_REPO" is instead set to the
221 basename of the directory that should be created when checking the
224 The "MR_CONFIG" environment variable is set to the .mrconfig file
225 that defines the repo being acted on, or, if the repo is not yet in a config
226 file, the .mrconfig file that should be modified to register the repo.
228 A few parameters have special meanings:
234 If the "skip" parameter is set and its command returns true, then B<mr>
235 will skip acting on that repository. The command is passed the action
238 Here are two examples. The first skips the repo unless
239 mr is run by joey. The second uses the hours_since function
240 (included in mr's built-in library) to skip updating the repo unless it's
241 been at least 12 hours since the last update.
243 skip = test `whoami` != joey
244 skip = [ "$1" = update ] && ! hours_since "$1" 12
248 The "order" parameter can be used to override the default ordering of
249 repositories. The default order value is 10. Use smaller values to make
250 repositories be processed earlier, and larger values to make repositories
253 Note that if a repository is located in a subdirectory of another
254 repository, ordering it to be processed earlier is not recommended.
258 If the "chain" parameter is set and its command returns true, then B<mr>
259 will try to load a .mrconfig file from the root of the repository. (You
260 should avoid chaining from repositories with untrusted committers.)
264 If the "include" parameter is set, its command is ran, and should output
265 additional mrconfig file content. The content is included as if it were
266 part of the including file.
268 Unlike all other parameters, this parameter does not need to be placed
273 The "lib" parameter can specify some shell code that will be run before each
274 command, this can be a useful way to define shell functions for other commands
279 When looking for a command to run for a given action, mr first looks for
280 a parameter with the same name as the action. If that is not found, it
281 looks for a parameter named "rcs_action" (substituting in the name of the
282 revision control system and the action). The name of the revision control
283 system is itself determined by running each defined "rcs_test" action,
286 Internally, mr has settings for "git_update", "svn_update", etc. To change
287 the action that is performed for a given revision control system, you can
288 override these rcs specific actions. To add a new revision control system,
289 you can just add rcs specific actions for it.
293 Copyright 2007 Joey Hess <joey@kitenet.net>
295 Licensed under the GNU GPL version 2 or higher.
297 http://kitenet.net/~joey/code/mr/
306 use Cwd qw(getcwd abs_path);
308 # things that can happen when mr runs a command
317 my $config_overridden=0;
323 my $directory=getcwd();
324 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
331 my (@ok, @failed, @skipped);
337 my ($action, $dir, $topdir, $subdir) = @_;
339 if (exists $rcs{$dir}) {
344 foreach my $rcs_test (
346 length $a <=> length $b
349 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
350 my ($rcs)=$rcs_test=~/(.*)_test/;
351 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
352 $test.="if my_$rcs_test; then echo $rcs; fi\n";
354 $test=$config{$topdir}{$subdir}{lib}."\n".$test
355 if exists $config{$topdir}{$subdir}{lib};
357 print "mr $action: running rcs test >>$test<<\n" if $verbose;
362 print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
366 return $rcs{$dir}=undef;
369 return $rcs{$dir}=$rcs;
373 sub findcommand { #{{{
374 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
376 if (exists $config{$topdir}{$subdir}{$action}) {
377 return $config{$topdir}{$subdir}{$action};
384 my $rcs=rcs_test(@_);
387 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
388 return $config{$topdir}{$subdir}{$rcs."_".$action};
396 my ($action, $dir, $topdir, $subdir) = @_;
398 $ENV{MR_CONFIG}=$configfiles{$topdir};
399 my $lib=exists $config{$topdir}{$subdir}{lib} ?
400 $config{$topdir}{$subdir}{lib}."\n" : "";
401 my $is_checkout=($action eq 'checkout');
405 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
409 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
411 elsif ($action =~ /update/) {
413 return action("checkout", $dir, $topdir, $subdir);
419 my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
420 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
422 if (defined $skiptest) {
423 my $test="set -e;".$lib.
424 "my_action(){ $skiptest\n }; my_action '$action'";
425 print "mr $action: running skip test >>$test<<\n" if $verbose;
426 my $ret=system($test);
428 if (($? & 127) == 2) {
429 print STDERR "mr $action: interrupted\n";
433 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
437 if ($ret >> 8 == 0) {
438 print "mr $action: $dir skipped per config file\n" if $verbose;
443 if ($is_checkout && ! -d $dir) {
444 print "mr $action: creating parent directory $dir\n" if $verbose;
445 system("mkdir", "-p", $dir);
448 if (! $no_chdir && ! chdir($dir)) {
449 print STDERR "mr $action: failed to chdir to $dir: $!\n";
452 elsif (! defined $command) {
453 my $rcs=rcs_test(@_);
454 if (! defined $rcs) {
455 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
459 print STDERR "mr $action: no defined action for $rcs repository $topdir$subdir, skipping\n";
465 print "mr $action: $topdir$subdir\n";
469 $s=~s/^\Q$topdir$subdir\E\/?//;
470 print "mr $action: $topdir$subdir (in subdir $s)\n";
472 $command="set -e; ".$lib.
473 "my_action(){ $command\n }; my_action ".
474 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
475 print "mr $action: running >>$command<<\n" if $verbose;
476 my $ret=system($command);
478 if (($? & 127) == 2) {
479 print STDERR "mr $action: interrupted\n";
483 print STDERR "mr $action: received signal ".($? & 127)."\n";
486 print STDERR "mr $action: failed ($ret)\n" if $verbose;
487 if ($ret >> 8 != 0) {
488 print STDERR "mr $action: command failed\n";
491 print STDERR "mr $action: command died ($ret)\n";
496 if ($action eq 'checkout' && ! -d $dir) {
497 print STDERR "mr $action: $dir missing after checkout\n";;
506 # run actions on multiple repos, in parallel
516 while (@fhs or @repos) {
517 while ((!$jobs || $running < $jobs) && @repos) {
519 my $repo = shift @repos;
520 pipe(my $outfh, CHILD_STDOUT);
521 pipe(my $errfh, CHILD_STDERR);
523 unless ($pid = fork) {
524 die "mr $action: cannot fork: $!" unless defined $pid;
525 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
526 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
531 exit action($action, @$repo);
535 push @active, [$pid, $repo];
536 push @fhs, [$outfh, $errfh];
539 my ($rin, $rout) = ('','');
541 foreach my $fh (@fhs) {
542 next unless defined $fh;
543 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
544 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
546 $nfound = select($rout=$rin, undef, undef, 1);
547 foreach my $channel (0, 1) {
548 foreach my $i (0..$#fhs) {
549 next unless defined $fhs[$i];
550 my $fh = $fhs[$i][$channel];
551 next unless defined $fh;
552 if (vec($rout, fileno($fh), 1) == 1) {
554 if (sysread($fh, $r, 1024) == 0) {
556 $fhs[$i][$channel] = undef;
557 if (! defined $fhs[$i][0] &&
558 ! defined $fhs[$i][1]) {
559 waitpid($active[$i][0], 0);
560 print STDOUT $out[$i][0];
561 print STDERR $out[$i][1];
562 record($active[$i][1], $? >> 8);
564 splice(@active, $i, 1);
569 $out[$i][$channel] .= $r;
577 my $dir=shift()->[0];
584 elsif ($ret == FAILED) {
588 elsif ($ret == SKIPPED) {
591 elsif ($ret == ABORT) {
595 die "unknown exit status $ret";
601 if (! @ok && ! @failed && ! @skipped) {
602 die "mr $action: no repositories found to work on\n";
604 print "mr $action: finished (".join("; ",
605 showstat($#ok+1, "ok", "ok"),
606 showstat($#failed+1, "failed", "failed"),
607 showstat($#skipped+1, "skipped", "skipped"),
611 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
614 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
624 return "$count ".($count > 1 ? $plural : $singular);
629 # an ordered list of repos
632 foreach my $topdir (sort keys %config) {
633 foreach my $subdir (sort keys %{$config{$topdir}}) {
637 order => $config{$topdir}{$subdir}{order},
642 $a->{order} <=> $b->{order}
644 $a->{topdir} cmp $b->{topdir}
646 $a->{subdir} cmp $b->{subdir}
650 # figure out which repos to act on
651 sub selectrepos { #{{{
653 foreach my $repo (repolist()) {
654 my $topdir=$repo->{topdir};
655 my $subdir=$repo->{subdir};
657 next if $subdir eq 'DEFAULT';
658 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
660 $dir.="/" unless $dir=~/\/$/;
661 $d.="/" unless $d=~/\/$/;
662 next if $dir ne $d && $dir !~ /^\Q$d\E/;
663 if (defined $max_depth) {
664 my @a=split('/', $dir);
665 my @b=split('/', $d);
666 do { } while (@a && @b && shift(@a) eq shift(@b));
667 next if @a > $max_depth || @b > $max_depth;
669 push @repos, [$dir, $topdir, $subdir];
672 # fallback to find a leaf repo
673 foreach my $repo (reverse repolist()) {
674 my $topdir=$repo->{topdir};
675 my $subdir=$repo->{subdir};
677 next if $subdir eq 'DEFAULT';
678 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
680 $dir.="/" unless $dir=~/\/$/;
681 $d.="/" unless $d=~/\/$/;
682 if ($d=~/^\Q$dir\E/) {
683 push @repos, [$dir, $topdir, $subdir];
693 sub loadconfig { #{{{
700 if (ref $f eq 'GLOB') {
709 my $absf=abs_path($f);
710 if ($loaded{$absf}) {
715 ($dir)=$f=~/^(.*\/)[^\/]+$/;
716 if (! defined $dir) {
719 $dir=abs_path($dir)."/";
721 if (! exists $configfiles{$dir}) {
722 $configfiles{$dir}=$f;
725 # copy in defaults from first parent
727 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
728 if ($parent eq '/') {
731 if (exists $config{$parent} &&
732 exists $config{$parent}{DEFAULT}) {
733 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
738 print "mr: loading config $f\n" if $verbose;
739 open($in, "<", $f) || die "mr: open $f: $!\n";
750 next if /^\s*\#/ || /^\s*$/;
751 if (/^\[([^\]]*)\]\s*$/) {
754 elsif (/^(\w+)\s*=\s*(.*)/) {
759 while (@lines && $lines[0]=~/^\s(.+)/) {
766 if ($parameter eq "include") {
767 print "mr: including output of \"$value\"\n" if $verbose;
768 unshift @lines, `$value`;
772 if (! defined $section) {
773 die "$f line $.: parameter ($parameter) not in section\n";
775 if ($section ne 'ALIAS' &&
776 ! exists $config{$dir}{$section} &&
777 exists $config{$dir}{DEFAULT}) {
779 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
781 if ($section eq 'ALIAS') {
782 $alias{$parameter}=$value;
784 elsif ($parameter eq 'lib') {
785 $config{$dir}{$section}{lib}.=$value."\n";
788 $config{$dir}{$section}{$parameter}=$value;
789 if ($parameter =~ /.*_(.*)/) {
793 $knownactions{$parameter}=1;
795 if ($parameter eq 'chain' &&
796 length $dir && $section ne "DEFAULT" &&
797 -e $dir.$section."/.mrconfig") {
798 my $ret=system($value);
800 if (($? & 127) == 2) {
801 print STDERR "mr: chain test interrupted\n";
805 print STDERR "mr: chain test received signal ".($? & 127)."\n";
809 push @toload, $dir.$section."/.mrconfig";
815 die "$f line $line: parse error\n";
824 sub modifyconfig { #{{{
826 # the section to modify or add
827 my $targetsection=shift;
828 # fields to change in the section
829 # To remove a field, set its value to "".
836 open(my $in, "<", $f) || die "mr: open $f: $!\n";
841 my $formatfield=sub {
843 my @value=split(/\n/, shift);
845 return "$field = ".shift(@value)."\n".
846 join("", map { "\t$_\n" } @value);
850 while ($out[$#out] =~ /^\s*$/) {
851 unshift @blanks, pop @out;
853 foreach my $field (sort keys %changefields) {
854 if (length $changefields{$field}) {
855 push @out, "$field = $changefields{$field}\n";
856 delete $changefields{$field};
866 if (/^\s*\#/ || /^\s*$/) {
869 elsif (/^\[([^\]]*)\]\s*$/) {
870 if (defined $section &&
871 $section eq $targetsection) {
879 elsif (/^(\w+)\s*=\s(.*)/) {
884 while (@lines && $lines[0]=~/^\s(.+)/) {
890 if ($section eq $targetsection) {
891 if (exists $changefields{$parameter}) {
892 if (length $changefields{$parameter}) {
893 $value=$changefields{$parameter};
895 delete $changefields{$parameter};
899 push @out, $formatfield->($parameter, $value);
903 if (defined $section &&
904 $section eq $targetsection) {
907 elsif (%changefields) {
908 push @out, "\n[$targetsection]\n";
909 foreach my $field (sort keys %changefields) {
910 if (length $changefields{$field}) {
911 push @out, $formatfield->($field, $changefields{$field});
916 open(my $out, ">", $f) || die "mr: write $f: $!\n";
924 # actions that do not operate on all repos
925 if ($action eq 'help') {
928 elsif ($action eq 'config') {
931 elsif ($action eq 'register') {
935 if (!$jobs || $jobs > 1) {
936 mrs($action, selectrepos());
939 foreach my $repo (selectrepos()) {
940 record($repo, action($action, @$repo));
946 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
951 die "mr config: not enough parameters\n";
954 if ($section=~/^\//) {
955 # try to convert to a path relative to the config file
956 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
958 $dir.="/" unless $dir=~/\/$/;
959 if ($section=~/^\Q$dir\E(.*)/) {
965 if (/^([^=]+)=(.*)$/) {
966 $changefields{$1}=$2;
970 foreach my $topdir (sort keys %config) {
971 if (exists $config{$topdir}{$section} &&
972 exists $config{$topdir}{$section}{$_}) {
973 print $config{$topdir}{$section}{$_}."\n";
975 last if $section eq 'DEFAULT';
979 die "mr config: $section $_ not set\n";
983 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
988 if (! $config_overridden) {
989 # Find the closest known mrconfig file to the current
991 $directory.="/" unless $directory=~/\/$/;
993 foreach my $topdir (reverse sort keys %config) {
994 next unless length $topdir;
995 if ($directory=~/^\Q$topdir\E/) {
996 $ENV{MR_CONFIG}=$configfiles{$topdir};
1002 if (! $foundconfig) {
1003 $directory=""; # no config file, use builtin
1007 my $subdir=shift @ARGV;
1008 if (! chdir($subdir)) {
1009 print STDERR "mr register: failed to chdir to $subdir: $!\n";
1013 $ENV{MR_REPO}=getcwd();
1014 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
1015 if (! defined $command) {
1016 die "mr register: unknown repository type\n";
1019 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1020 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1021 "my_action(){ $command\n }; my_action ".
1022 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1023 print "mr register: running >>$command<<\n" if $verbose;
1024 exec($command) || die "exec: $!";
1027 # alias expansion and command stemming
1028 sub expandaction { #{{{
1030 if (exists $alias{$action}) {
1031 $action=$alias{$action};
1033 if (! exists $knownactions{$action}) {
1034 my @matches = grep { /^\Q$action\E/ }
1035 keys %knownactions, keys %alias;
1036 if (@matches == 1) {
1037 $action=$matches[0];
1039 elsif (@matches == 0) {
1040 die "mr: unknown action \"$action\" (known actions: ".
1041 join(", ", sort keys %knownactions).")\n";
1044 die "mr: ambiguous action \"$action\" (matches: ".
1045 join(", ", @matches).")\n";
1052 Getopt::Long::Configure("bundling", "no_permute");
1053 my $result=GetOptions(
1054 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1055 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1056 "v|verbose" => \$verbose,
1057 "s|stats" => \$stats,
1058 "n|no-recurse:i" => \$max_depth,
1059 "j|jobs:i" => \$jobs,
1061 if (! $result || @ARGV < 1) {
1062 die("Usage: mr [-d directory] action [params ...]\n".
1063 "(Use mr help for man page.)\n");
1069 print STDERR "mr: interrupted\n";
1073 # This can happen if it's run in a directory that was removed
1074 # or other strangeness.
1075 if (! defined $directory) {
1076 die("mr: failed to determine working directory\n");
1078 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1079 # the config file might be a symlink to elsewhere, and the directory it's
1080 # in is significant.
1081 if ($ENV{MR_CONFIG} !~ /^\//) {
1082 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1084 # Try to set MR_PATH to the path to the program.
1086 use FindBin qw($Bin $Script);
1087 $ENV{MR_PATH}=$Bin."/".$Script;
1095 loadconfig($ENV{MR_CONFIG});
1096 #use Data::Dumper; print Dumper(\%config);
1098 my $action=expandaction(shift @ARGV);
1105 elsif (! @ok && @skipped) {
1113 # Finally, some useful actions that mr knows about by default.
1114 # These can be overridden in ~/.mrconfig.
1130 echo "mr (warning): $@" >&2
1136 if [ -z "$1" ] || [ -z "$2" ]; then
1137 error "mr: usage: hours_since action num"
1139 for dir in .git .svn .bzr CVS .hg _darcs; do
1140 if [ -e "$MR_REPO/$dir" ]; then
1141 flagfile="$MR_REPO/$dir/.mr_last$1"
1145 if [ -z "$flagfile" ]; then
1146 error "cannot determine flag filename"
1148 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1149 if [ "$delta" -lt "$2" ]; then
1157 svn_test = test -d "$MR_REPO"/.svn
1158 git_test = test -d "$MR_REPO"/.git
1159 bzr_test = test -d "$MR_REPO"/.bzr
1160 cvs_test = test -d "$MR_REPO"/CVS
1161 hg_test = test -d "$MR_REPO"/.hg
1162 darcs_test = test -d "$MR_REPO"/_darcs
1164 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1165 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1166 test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
1168 svn_update = svn update "$@"
1175 bzr_update = bzr merge "$@"
1176 cvs_update = cvs update "$@"
1177 hg_update = hg pull "$@" && hg update "$@"
1178 darcs_update = darcs pull -a "$@"
1180 svn_status = svn status "$@"
1181 git_status = git status "$@" || true
1182 bzr_status = bzr status "$@"
1183 cvs_status = cvs status "$@"
1184 hg_status = hg status "$@"
1185 darcs_status = darcs whatsnew -ls "$@"
1187 svn_commit = svn commit "$@"
1188 git_commit = git commit -a "$@" && git push --all
1189 bzr_commit = bzr commit "$@" && bzr push
1190 cvs_commit = cvs commit "$@"
1191 hg_commit = hg commit -m "$@" && hg push
1192 darcs_commit = darcs record -a -m "$@" && darcs push -a
1194 svn_diff = svn diff "$@"
1195 git_diff = git diff "$@"
1196 bzr_diff = bzr diff "$@"
1197 cvs_diff = cvs diff "$@"
1198 hg_diff = hg diff "$@"
1199 darcs_diff = darcs diff "$@"
1201 svn_log = svn log "$@"
1202 git_log = git log "$@"
1203 bzr_log = bzr log "$@"
1204 cvs_log = cvs log "$@"
1205 hg_log = hg log "$@"
1206 darcs_log = darcs changes "$@"
1207 git_bare_log = git log "$@"
1210 url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
1211 if [ -z "$url" ]; then
1212 error "cannot determine svn url"
1214 echo "Registering svn url: $url in $MR_CONFIG"
1215 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1217 url="`LC_ALL=C git config --get remote.origin.url`" || true
1218 if [ -z "$url" ]; then
1219 error "cannot determine git url"
1221 echo "Registering git url: $url in $MR_CONFIG"
1222 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1224 url=`cat .bzr/branch/parent`
1225 if [ -z "$url" ]; then
1226 error "cannot determine bzr url"
1228 echo "Registering bzr url: $url in $MR_CONFIG"
1229 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1231 repo=`cat CVS/Repository`
1233 if [ -z "$root" ]; then
1234 error "cannot determine cvs root"
1236 echo "Registering cvs repository $repo at root $root"
1237 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1239 url=`hg showconfig paths.default`
1240 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1241 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1243 url=`cat _darcs/prefs/defaultrepo`
1244 echo "Registering darcs repository $url in $MR_CONFIG"
1245 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
1247 url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
1248 if [ -z "$url" ]; then
1249 error "cannot determine git url"
1251 echo "Registering git url: $url in $MR_CONFIG"
1252 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1255 if [ ! -e "$MR_PATH" ]; then
1256 error "cannot find program path"
1258 tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
1259 trap "rm -f $tmp" exit
1260 pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
1261 man -l "$tmp" || error "man failed"
1265 ed = echo "A horse is a horse, of course, of course.."
1266 T = echo "I pity the fool."
1267 right = echo "Not found."
1270 # vim:sw=8:sts=0:ts=8:noet